﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;

namespace HeuristicLab.Hive.Slave.Core {
  internal static class Logger {
    private const int MaxMessageCount = 1000;

    private static object locker = new object();
    private static ILog log = new Log();

    public static ILog Log {
      get { return log; }
    }

    public static void Debug(object message) {
      lock (locker) {
        LimitLog();
        Log.LogMessage(message.ToString());
        HeuristicLab.Hive.Tracing.Logger.Debug(message);
      }
    }

    public static void Info(object message) {
      lock (locker) {
        LimitLog();
        Log.LogMessage(message.ToString());
        HeuristicLab.Hive.Tracing.Logger.Info(message);
      }
    }

    public static void Warn(object message) {
      lock (locker) {
        LimitLog();
        Log.LogMessage(message.ToString());
        HeuristicLab.Hive.Tracing.Logger.Warn(message);
      }
    }

    public static void Error(object message) {
      lock (locker) {
        LimitLog();
        Log.LogMessage(message.ToString());
        HeuristicLab.Hive.Tracing.Logger.Error(message);
      }
    }

    public static void Error(object message, Exception e) {
      lock (locker) {
        LimitLog();
        Log.LogException(e);
        HeuristicLab.Hive.Tracing.Logger.Error(message);
      }
    }

    private static void LimitLog() {
      if (Log.Messages.Count() > MaxMessageCount) {
        Log.Clear();
      }
    }
  }
}
